﻿############################################################################
#    Copyright (C) 2006 by Cesar Kallas
#    cesarkallas@soulivre.org - http://cesarkallas.soulivre.org
#		
#    This program is free software; you can redistribute it and#or modify 
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or 
#    (at your option) any later version.                             
#                                                                          
#    This program is distributed in the hope that it will be useful,       
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         
#    GNU General Public License for more details.                          
#                                                                          
#    You should have received a copy of the GNU General Public License     
#    along with this program; if not, write to the                         
#    Free Software Foundation, Inc.,                                       
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             
############################################################################

from qt import *
from agenteGui import *
import sys

''' 
Classe que gerencia agentes (cadastro, exclusao, edicao)
Entradas: self.agentegui.py (tela grafica do agente)
Desde: 13/08/2006
'''
class gerenciaAgente:
	
	global agentegui, cursor

	def __selecionarGrupos__(self):
		self.agentegui.grupos.selectAll(1)
		
	# Habilita objetos da interface grafica
	def __habilitarObjetosTela__(self, opcao):
		self.agentegui.tabs.setEnabled(True)
		self.agentegui.hardware.setEnabled(True)
		self.agentegui.informacoes.setEnabled(True)
		self.agentegui.botaoProcurar.setEnabled(True)
		self.agentegui.procurar.clear()
		self.agentegui.procurar.setFocus()
		
		# Tab informacoes
		self.agentegui.apelido.setEnabled(opcao)
		self.agentegui.apelido.clear()
		self.agentegui.grupos.setEnabled(opcao)
		self.agentegui.grupos.clear()
		self.agentegui.botaoSelecionarGrupos.setEnabled(opcao)
		self.agentegui.botaoLimparSelecaoGrupos.setEnabled(opcao)
		self.agentegui.botaoEditarGrupos.setEnabled(opcao)
		self.agentegui.responsavel.setEnabled(opcao)
		self.agentegui.responsavel.clear()
		self.agentegui.telefone.setEnabled(opcao)
		self.agentegui.telefone.clear()
		self.agentegui.setor.setEnabled(opcao)
		self.agentegui.setor.clear()
		self.agentegui.localizacao.setEnabled(opcao)
		self.agentegui.localizacao.clear()
		self.agentegui.observacao.setEnabled(opcao)
		self.agentegui.observacao.clear()

		# Tab hardware
		self.agentegui.mac_address.setEnabled(opcao)
		self.agentegui.mac_address.clear()
		self.agentegui.processador.setEnabled(opcao)
		self.agentegui.processador.clear()
		self.agentegui.disquete.setEnabled(opcao)
		self.agentegui.disquete.setChecked(0)
		self.agentegui.memoria_ram.setEnabled(opcao)
		self.agentegui.memoria_ram.clear()
		self.agentegui.disco_rigido.setEnabled(opcao)
		self.agentegui.disco_rigido.clear()
		self.agentegui.drive.setEnabled(opcao)
		self.agentegui.drive.clear()
		self.agentegui.rede.setEnabled(opcao)
		self.agentegui.rede.clear()
		self.agentegui.fabricante.setEnabled(opcao)
		self.agentegui.fabricante.clear()
		self.agentegui.numero_serial.setEnabled(opcao)
		self.agentegui.numero_serial.clear()
		self.agentegui.modelo.setEnabled(opcao)
		self.agentegui.modelo.clear()
	
	def __preencherTela__(self, agente):
		self.agentegui.mac_address.setText(agente[0])
		self.agentegui.apelido.setText(agente[1])
		self.agentegui.localizacao.setText(agente[2])
		self.agentegui.responsavel.setText(agente[3])
		self.agentegui.setor.setText(agente[4])
		self.agentegui.processador.setText(agente[5])
		self.agentegui.memoria_ram.setText(agente[6])
		self.agentegui.disco_rigido.setText(agente[7])
		self.agentegui.fabricante.setText(agente[8])
		self.agentegui.modelo.setText(agente[9])
		self.agentegui.numero_serial.setText(agente[10])
		self.agentegui.ultimo_ip.setText(agente[11])
		#self.agentegui.disquete = agente[12]
		self.agentegui.telefone.setText(agente[13])
		self.agentegui.observacao.setText(agente[14])
		self.agentegui.drive.setText(agente[15])
		self.agentegui.rede.setText(agente[16])
	
	def __procurar__(self):
		# Verifica se ja existe o endereco de mac cadastrado na base
		self.cursor.execute("""SELECT * FROM agente WHERE mac_address=%s""",  (self.agentegui.procurar.text()))
		agente = self.cursor.fetchone()
		if len(self.agentegui.procurar.text()) < 1:
			self.agentegui.labelStatus.setText("DIGITE O MAC ADDRESS DO AGENTE")
		else:
			if agente != None:
				self.__preencherTela__(agente)
				self.agentegui.botaoCancelarExcluir.setEnabled(True)
			else:
				self.agentegui.labelStatus.setText("AGENTE NAO ENCONTRADO")
	
	# Adiciona um novo agente
	def __adicionar__(self):
		# Habilita tela para adicionar agente
		self.__habilitarObjetosTela__(True)
		self.agentegui.apelido.setFocus()
		self.agentegui.botaoAdicionar.setEnabled(False)
		self.agentegui.botaoSalvar.setEnabled(True)
		self.agentegui.botaoCancelarExcluir.setEnabled(True)
		self.agentegui.botaoCancelarExcluir.setText(QString("&Cancelar"))
		self.agentegui.procurar.setEnabled(False)
		self.agentegui.botaoProcurar.setEnabled(False)
						
	def __salvar__(self):
		# Salva os dados do novo agente
		if(len(self.agentegui.apelido.text()) < 1):
			QMessageBox.information(None, "Dados incompletos", 
				QString("Digite um apelido para o agente."))
			self.agentegui.tabs.setCurrentPage(0)
			self.agentegui.apelido.setFocus()
		elif(len(self.agentegui.mac_address.text()) != 18):
			QMessageBox.information(None, "Dados incompletos", 
				QString("Digite corretamente o endereco do Mac Address."))
			self.agentegui.tabs.setCurrentPage(1)
			self.agentegui.mac_address.setFocus()
		else:
			# Verifica se ja existe o endereco de mac cadastrado na base
			self.cursor.execute("""SELECT * FROM agente WHERE mac_address=%s""",  (self.agentegui.mac_address.text()))
			agente = self.cursor.fetchone()
			if(agente != None):
				# Se ja existir na base de dados, ele vai retornar os valores para a tela
				QMessageBox.critical(None, "Falha ao cadastrar agente", 
				QString("O endereco de Mac Address ja consta na base de dados."))
				self.__preencherTela__(agente)
			else:
				# Cadastra agente na base
				#cursor.execute("INSERT INTO agente (apelido, mac_address, processador, drive, rede, fabricante, numero_serial, modelo, disquete, memoria_ram, disco_rigido) values (%s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s)", (self.agentegui.apelido.text(), self.agentegui.mac_address.text(), self.agentegui.processador.text(), self.agentegui.drive.text(), self.agentegui.rede.text(), self.agentegui.fabricante.text(), self.agentegui.numero_serial.text(), self.agentegui.modelo.text(), self.agentegui.disquete.isOn(), self.agentegui.memoria_ram.text(), self.agentegui.disco_rigido.text()))
				self.cursor.execute("INSERT INTO agente (apelido, responsavel, telefone, setor, localizacao, observacao, mac_address, processador, disquete, memoria_ram, disco_rigido, drive, rede, fabricante, numero_serial, modelo) values (%s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s)", (self.agentegui.apelido.text(), self.agentegui.responsavel.text(), self.agentegui.telefone.text(), self.agentegui.setor.text(), self.agentegui.localizacao.text(), self.agentegui.observacao.text(), self.agentegui.mac_address.text(), self.agentegui.processador.text(), self.agentegui.disquete.isOn(), self.agentegui.memoria_ram.text(), self.agentegui.disco_rigido.text(), self.agentegui.drive.text(), self.agentegui.rede.text(), self.agentegui.fabricante.text(), self.agentegui.numero_serial.text(), self.agentegui.modelo.text()))
				self.agentegui.botaoAdicionarSalvar.setEnabled(True)
				self.agentegui.botaoCancelarExcluir.setText(QString("E&xcluir"))
				self.agentegui.procurar.setEnabled(True)
				self.agentegui.botaoProcurar.setEnabled(True)
				
	def __cancelarExcluir__(self):
		# Cancela edicao
		if self.agentegui.botaoCancelarExcluir.text() == "&Cancelar":
				self.__habilitarObjetosTela__(False)
				self.agentegui.botaoAdicionar.setEnabled(True)
				self.agentegui.botaoSalvar.setEnabled(False)
				self.agentegui.botaoProcurar.setEnabled(True)
				self.agentegui.procurar.setEnabled(True)
				self.agentegui.botaoCancelarExcluir.setText(QString("E&xcluir"))	
				if len(self.agentegui.mac_address.text()) != 18:
					self.agentegui.botaoCancelarExcluir.setEnabled(False)
		else:
			# Verifica se ja existe o endereco de mac cadastrado na base e o exclui
			self.cursor.execute("""DELETE FROM agente WHERE mac_address=%s""",  (self.agentegui.mac_address.text()))
	
	def __sinais__(self):
		self.agentegui.connect(self.agentegui.botaoAdicionar, SIGNAL('clicked()'), self.__adicionar__)
		self.agentegui.connect(self.agentegui.botaoSalvar, SIGNAL('clicked()'), self.__salvar__)
		self.agentegui.connect(self.agentegui.botaoProcurar, SIGNAL('clicked()'), self.__procurar__)
		self.agentegui.connect(self.agentegui.botaoCancelarExcluir, SIGNAL('clicked()'), self.__cancelarExcluir__)
		self.agentegui.connect(self.agentegui.botaoSelecionarGrupos, SIGNAL('clicked()'), self.__selecionarGrupos__)
		self.__habilitarObjetosTela__(False)
	
	def gui(self):
		return self.agentegui
	
	def __init__(self, bd):
		self.agentegui = agenteGui()
		self.__sinais__()
		self.cursor = bd.cursor()